package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.types.Color;

import static dev.pfaff.altargui.GuiGlobals.GL;

/**
 * This does not work. I've left it here to be fixed in the future.
 */
public final class PathfinderDemo {
	private static final PFRendererMode RENDER_MODE = PFRendererMode.PF_RENDERER_LEVEL_D3D9;

	public static final Pathfinder PATHFINDER = new Pathfinder(GL.symbolLookup());

	private static final PFGLDeviceRef device = PATHFINDER.createDevice(PFGLVersion.PF_GL_VERSION_GL3);
	private static final PFResourceLoaderRef resourceLoader = PATHFINDER.createEmbeddedResourceLoader();
//	private static final PFGLDestFramebufferRef framebuffer = PATHFINDER.createFullWindowFramebufferRef(1, 1);
	private static final PFGLDestFramebufferRef framebuffer = PATHFINDER.createFullWindowFramebufferRef(800, 600);
	public static final PFGLRendererRef pfRenderer = PFGLRendererRef.create(device,
			resourceLoader,
			RENDER_MODE,
			framebuffer);
	private static final PFCanvasFontContextRef fontContext = PATHFINDER.createSystemFontContext();
	private static final PFBuildOptionsRef options = PATHFINDER.createBuildOptions();
//	private static final PFCanvasRef canvas = PATHFINDER.createCanvas(fontContext, WIDTH, HEIGHT);
//	private static final PFSceneRef scene = canvas.createScene();
//	private static final PFSceneProxyRef sceneProxy = scene.createProxy(RENDER_MODE);

	//	private static final PFFillStyleRef colorBlue = PFFillStyleRef.createColor(Color.fromRgba(0, 0, 255, 255));
	private static final PFFillStyleRef colorWhite = PFFillStyleRef.createColor(Color.WHITE);
//	private static final PFFillStyleRef colorWhite = PFFillStyleRef.createColor(Color.TRANSPARENT);
	private static final PFFillStyleRef colorDark = PFFillStyleRef.createColor(Color.fromRgba(255, 0, 255, 255));

	public static void render(float width, float height) {
//		while (true) {
//			GuiGlobals.GL.glClearColor(0f, 0f, 0f, 0f);
//			GuiGlobals.GL.glClear(0x4000);

		var canvas = PATHFINDER.createCanvas(fontContext, width, height);

//		canvas.clear();
		canvas.setFillStyle(colorWhite);
		canvas.fillRect(0f, 0f, 200, 100);
//			canvas.setFillStyle(colorBlue);
		canvas.setFillStyle(colorDark);
//			canvas.fillRect(4f, 4f, 20f, 20f);
//			canvas.setFillStyle(colorWhite);
		canvas.setFont("Monocraft");
		canvas.setFontSize(32f);
		canvas.fillText("Hello from Pathfinder", 4f, 32f + 4f);

		var scene = canvas.createScene();
		var sceneProxy = scene.createMultiThreadedProxy(RENDER_MODE);
//			var sceneProxy = scene.createSingleThreadedProxy(RENDER_MODE);

//		GL.glFinish();
//		GL.glDisable(GLEnableCap.DEPTH_TEST);
//		GL.glDepthMask(false);
//		GL.glDisable(GLEnableCap.BLEND);

		sceneProxy.buildAndRenderGL(pfRenderer, options);

//			GL.gl.glFlush();
//			GuiGlobals.GL.glFinish();
//			mcWindow.swapBuffers();
//			GuiGlobals.GL.glFinish();
//			try {
//				Thread.sleep(2000);
//			} catch (InterruptedException e) {
//				throw new RuntimeException(e);
//			}
//		}
	}
}
